/* TestADT.java  8 February 2003 */

import java.awt.*;

public class TestADT extends JPFalt 
{
    public static void main(String[] args) { new TestADT(); }
    
    //////////////////////////////////////////////////////////
    // Place your actual methods here.                      //
    //////////////////////////////////////////////////////////

	/** Test suite for the class Person */
	
	/*--------------------------------------------------------
	 Define a Person object and print the member data values.
	--------------------------------------------------------*/
    public void TestPerson(){
    
    	println("\nDefine Person objects, print member data");
    	println(new Person("Donald", Color.blue, 1999));
    	println(new Person("Minnie", Color.green, 1925));
    }
    
	/*-------------------------------------------------------- 
	 Test the initial() method
	--------------------------------------------------------*/

    public void TestInitial(){
    	testHeader("initial()");
    	
    	/*----------------------------------------------------
    	 Define three Person objects. 
    	----------------------------------------------------*/
    	Person eeny  = new Person("Duck",  Color.blue, 1999);
    	Person meeny = new Person("Minnie", Color.green, 1925);
    	Person miny  = new Person("Mickey", Color.black, 1925);
    	    	
    	expected('D');
    	actual( eeny.initial() );
    	
    	expected('M');
    	actual( meeny.initial());
  	
    	expected('M');
    	actual( miny.initial());
    }
/*------------------------------------------------------------   	
 End of test suite for class Person
	--------------------------------------------------------*/
	
    void TestTreeTn(){
    	testHeader("constructor");
    	
    	/*--------------------------------------------------------------------- 
    	 Define three Tree objects. 
    	---------------------------------------------------------------------*/

        /* empty list of children, empty descendant tree */
        EmptyLoc emptyChildren = new EmptyLoc();
        EmptyADT  emptyTree     = new EmptyADT();
        
        /* a few persons to be included among descendants */
        Person carl = new Person("Carl", Color.green, 1950);
        Person jane = new Person("Jane", Color.blue,  1972);
        Person pete = new Person("Pete", Color.black, 1977);
        Person joe  = new Person("Joe",  Color.gray,  1979);
        
        println("The people");
        println(carl);
        println(jane);
        println(pete);
        println(joe);
        println(" ");
        
        /* youngest children - with no further descedants */        
        ADT peteADT = new ConsADT(pete, emptyChildren);
        ADT janeADT = new ConsADT(jane, emptyChildren);
        ADT joeADT  = new ConsADT(joe,  emptyChildren);
        
        println("The youngest descendants:");
        println(janeADT);
        println(peteADT);
        println(joeADT);
        println(" ");
       
        
        /* list of three sibblings */
        ALoc kids   = new ConsLoc(joeADT, 
                        new ConsLoc(peteADT,
                          new ConsLoc(janeADT, emptyChildren)));
        
        println("The sibblings");
        println(kids);
         
        /* carl - the father of the three */
        ADT carlADT = new ConsADT(carl, kids);
                                   
        println("\nFather and the kids:");
        println(carlADT);
        
        println("\nCount the nodes:");
        expected(4);
        actual  (carlADT.count());
        
        expected(1);
        actual  (janeADT.count());
        
    }
}
